#include "elements.inc"

#declare TestTxt = 0;

#declare FacadeTxt = texture {
	#if(TestTxt)
		pigment{color rgb 0.8}
	#else
		pigment{
			image_map{
				jpeg "imagemap/house11.jpg"
				map_type 0
			}
		}
		finish{diffuse 0.65}
	#end
}

#declare BoardTxt = texture {
	#if(TestTxt)
		pigment{color rgb 0.8}
	#else
		pigment{
			image_map{
				jpeg "imagemap/boards1.jpg"
				map_type 0
			}
		}
		finish{diffuse 0.65}
	#end
}

#declare GridTxt = texture{
    pigment{color rgb<0.32, 0.3, 0>}
   	finish{phong 0.2 phong_size 50 metallic 0.34}
}

#declare Glass = object{
	E1
	pigment{color rgb<0.5, 0.58, 0.6>}
	finish{diffuse 0.7 phong 0.5 reflection 0.2}
}

#declare WindowFrame1 = union {
	intersection{
		union{
	  		cylinder{<-1, 0, 0>, <1, 0, 0>, 0.0008}
	  		cylinder{<-1, 0.005, 0>, <1, 0.005, 0>, 0.0008}
	  		cylinder{<-1, 0.01, 0>, <1, 0.01, 0>, 0.0008}
	  		cylinder{<-1, 0.015, 0>, <1, 0.015, 0>, 0.0008}
	  		cylinder{<-1, 0.02, 0>, <1, 0.02, 0>, 0.0008}
	  		cylinder{<-1, 0.025, 0>, <1, 0.025, 0>, 0.0008}
	  		cylinder{<-1, 0.03, 0>, <1, 0.03, 0>, 0.0008}
	  		cylinder{<-1, 0.035, 0>, <1, 0.035, 0>, 0.0008}
	  		
	  		rotate z*60
	  		translate x*0.02
	  	}
	  	box{<0.004, 0.004, -1>, <0.03 - 0.004, 0.05 - 0.004, 1>}
	}
	intersection{
		union{
	  		cylinder{<-1, 0, 0>, <1, 0, 0>, 0.0008}
	  		cylinder{<-1, 0.005, 0>, <1, 0.005, 0>, 0.0008}
	  		cylinder{<-1, 0.01, 0>, <1, 0.01, 0>, 0.0008}
	  		cylinder{<-1, 0.015, 0>, <1, 0.015, 0>, 0.0008}
	  		cylinder{<-1, 0.02, 0>, <1, 0.02, 0>, 0.0008}
	  		cylinder{<-1, 0.025, 0>, <1, 0.025, 0>, 0.0008}
	  		cylinder{<-1, 0.03, 0>, <1, 0.03, 0>, 0.0008}
	  		cylinder{<-1, 0.035, 0>, <1, 0.035, 0>, 0.0008}
	  		
	  		rotate -z*60
	  		translate x*0.01
	  	}
	  	box{<0.004, 0.004, -1>, <0.03 - 0.004, 0.05 - 0.004, 1>}
	}
	
	object{Glass scale<0.022, 0.042, 1> translate<0.004, 0.004, 0.001>}
	
	texture{GridTxt}
}

#declare Blinders1 = union {
	object{E6 scale<0.02, 0.07, 0.002>}
	object{E5 scale<0.02, 0.003, 0.002> translate<0, 0.015, -0.002> texture{BoardTxt scale<0.02, 0.09, 1> rotate z*90}}
	object{E5 scale<0.02, 0.003, 0.002> translate<0, 0.06, -0.002> texture{BoardTxt scale<0.02, 0.09, 1> rotate z*90}}
	difference {
		cylinder{0, <0, 0, 0.002>, 0.02}
		plane{y, 0}
		plane{-x, 0}
		translate<0.02, 0.07, 0>
	}
	texture{BoardTxt scale<0.02, 0.09, 1>}
}
#declare Blinders2 = union {
	object{E6 scale<0.02, 0.07, 0.002>}
	object{E5 scale<0.02, 0.003, 0.002> translate<0, 0.015, -0.002> texture{BoardTxt scale<0.02, 0.09, 1> rotate z*90}}
	object{E5 scale<0.02, 0.003, 0.002> translate<0, 0.06, -0.002> texture{BoardTxt scale<0.02, 0.09, 1> rotate z*90}}
	difference {
		cylinder{0, <0, 0, 0.002>, 0.02}
		plane{y, 0}
		plane{x, 0}
		translate<0, 0.07, 0>
	}
	texture{BoardTxt scale<0.02, 0.09, 1>}
}

#declare Window1 = union {  
	object{E5 scale<0.004, 0.05, 0.03>}
	object{E5 scale<0.004, 0.05, 0.03> translate<0.03 - 0.004, 0, 0>}
	object{E3 scale<0.022, 0.004, 0.03> translate x*0.004}
	object{E3 scale<0.022, 0.004, 0.03> translate <0.004, 0.05 - 0.004, 0>}
	                             
	object{WindowFrame1 translate z*0.002}
}

#declare WindowFrame2 = union {
	object{E5 scale<0.03, 0.002, 0.03> translate <0.005, 0.005, 0.002>}
	object{E5 scale<0.03, 0.002, 0.03> translate <0.005, 0.07 - 0.002, 0.002>}
	object{E5 scale<0.03, 0.002, 0.03> translate <0.005, 0.05 - 0.002, 0.002>}
	
	object{E5 scale<0.002, 0.065, 0.03> translate <0.005, 0.005, 0.002>} 
	object{E5 scale<0.002, 0.065, 0.03> translate <0.02 - 0.001, 0.005, 0.002>}
	object{E5 scale<0.002, 0.065, 0.03> translate <0.035 - 0.002, 0.005, 0.002>}
	
	difference {
		cylinder{0, <0, 0, 0.03>, 0.015}
		cylinder{<0, 0, -1>, <0, 0, 1>, 0.013}
		plane{y, 0}
		translate<0.02, 0.07, 0.002>
	}
	
	intersection {
		object{Glass scale<0.032, 0.09, 1> translate<0.004, 0.004, 0.0025>}
		merge {
			cylinder{<0.02, 0.07, -1>, <0.02, 0.07, 1>, 0.015}
			box{<0.004, 0.004, -1>, <0.036, 0.07, 1>}
		}
	}    
}

#declare Window2 = union {                                 
	object{E5 scale<0.03, 0.004, 0.03> translate<0.005, -0.004, 0.001>}

	object{E5 scale<0.03, 0.005, 0.03> translate<0.005, 0, 0>}
	object{E5 scale<0.005, 0.07, 0.03>}
	object{E5 scale<0.005, 0.07, 0.03> translate x*0.035}
	     
	difference {
		cylinder{0, <0, 0, 0.03>, 0.02}
		cylinder{<0, 0, -1>, <0, 0, 1>, 0.015}
		plane{y, 0}
		translate<0.02, 0.07, 0>
	}
	
	object{WindowFrame2}
}

#declare Window3 = union {
	difference{
		box{0, <0.03, 0.03, 0.005>}
		box{<0.005, 0.005, -1>, <0.025, 0.025, 1>}
	}
}

#declare House1 = union {
	// facade
	difference{
		object{E1 scale<0.24, 0.55, 1> translate -y*0.1}
		box{<0.005, 0.005, -1>, <0.025, 0.025, 1> translate<0.015, 0.37, -0.002>}
		box{<0.005, 0.005, -1>, <0.025, 0.025, 1> translate<0.105, 0.37, -0.002>}
		box{<0.005, 0.005, -1>, <0.025, 0.025, 1> translate<0.195, 0.37, -0.002>}
	}
		
	// bars
	object{E5 scale<0.24, 0.006, 0.3> translate<0, 0.45, -0.002>}
	object{E5 scale<0.24, 0.004, 0.3> translate<0, 0.456, -0.003>}	
	
	// 1st floor
	object{Window1 translate<0.02, 0.08, -0.0035>}
	object{Window1 translate<0.105, 0.08, -0.0035>}
	object{Window1 translate<0.19, 0.08, -0.0035>}
	
	// 2nd floor
	object{Window2 translate<0.015, 0.21, -0.008>}
	object{Window2 translate<0.1, 0.21, -0.008>}
	object{Window2 translate<0.185, 0.21, -0.008>}
	
	// 3rd floor
	object{Window3 translate<0.015, 0.37, -0.002>}
	object{Window3 translate<0.105, 0.37, -0.002>}
	object{Window3 translate<0.195, 0.37, -0.002>}
	 
	// blinders
	object{Blinders1 rotate y*80 translate<0.22, 0.21, -0.0105>}
	object{Blinders2 rotate -y*10 translate<0.17, 0.21, -0.012>}       
	object{E6 scale<0.02, 0.02, 0.001> texture{BoardTxt scale<0.02, 0.09, 1>} rotate y*96 translate<0.22, 0.375, -0.0023>}
	  
	texture{FacadeTxt scale<0.24, 0.56, 1> translate<0, -0.1, 0>}
}